/*  
 *  prototyp.c -- ukzka programu s chybou!
 *
 *  demonstrace nutnosti pouvat prototypy funkc v ISO C90/C99
 *
 */

#include <stdio.h>      /* prototyp  int printf(const char *, ...)   */

int main()              /* funkce main mus bt jen jedna            */
{

  printf("Ukzka voln funkce bez deklarace\n");

  /* bez prototypu peklada implicitn pedpokld int f() */
  printf("Voln bez prototypu: i = f(1)\n");
  int i = f(1); /* funkce f dostane argument typu int, 
                   ale m ve skutenosti parametr typu double 
                   -- hrub CHYBA */
  /* peklada varuje (gcc -Wall) 
   * prototype.c:18: warning: implicit declaration of function `f'
   */
  printf("Vsledek: %d\n", i);

  /* prototyp peklada informuje jak jsou parametry/typ funkce */
  int f(double x);

  printf("Voln s prototypem: i = f(1)\n");
  i = f(1);  /* peklada automaticky provede konverzi: (double)1 
                a voln probhne O.K. */
  printf("Vsledek: %d\n", i);

  return 0;
}

/* definice funkce -- me bt v jinm modulu */
int f(double x)
{
    printf("Funkce dostala parametr x = %f\n", x);
    return x; /* tato funkce vrac celoselnou hodnotu x */
              /* Poznmka: zkuste si  x == 1e20 */
}

